REM http://www.openscenegraph.org/downloads/developer_releases/OpenSceneGraph-3.1.7.zip
REM 3.1.8 and above don't work with osgearth 2.4

set OSGEO4W_ROOT=C:\OSGeo4W
set P=osg
set V=3.1.7
set B=1

set R=..\..\..\release\%P%
for %%i in (bin dev libs) do (
	if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
	copy %%i.hint %R%\%P%-%%i\setup.hint
	copy ..\LICENSE.txt %R%\%P%-%%i\%P%-%%i-%V%-%B%.txt
)

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
path %SYSTEMROOT%\system32;%SYSTEMROOT%;%SYSTEMROOT%\System32\Wbem;%pf%\CMake\bin
call "%pf%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x86
path %pf%\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%
set OLDPATH=%PATH%
call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
path %OLDPATH%;%OSGEO4W_ROOT%\bin;c:\cygwin\bin
echo on

if not exist build32 mkdir build32
if not exist install32 mkdir install32
set INSTDIR=%CD%\install32
cd build32

set LIB=%LIB%;%OSGEO4W_ROOT%\lib
set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include

set BUILDCONF=RelWithDebInfo

cmake -G "Visual Studio 10" ^
	-DCMAKE_CONFIGURATION_TYPES=%BUILDCONF% ^
        -DJPEG_LIBRARY=%OSGEO4W_ROOT%/lib/jpeg_i.lib ^
        -DPNG_LIBRARY=%OSGEO4W_ROOT%/lib/libpng13.lib ^
        -DTIFF_LIBRARY=%OSGEO4W_ROOT%/lib/libtiff_i.lib ^
        -DCURL_LIBRARY=%OSGEO4W_ROOT%/lib/libcurl_imp.lib ^
        -DPROJECT_BINARY_DIR=%OSGEO4W_ROOT%/apps/openscenegraph ^
        -DCMAKE_RELWITHDEBINFO_POSTFIX= ^
	-DCMAKE_INSTALL_PREFIX=%INSTDIR% ^
        ..\..
if errorlevel 1 goto error

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
	echo %%i: %DATE% %TIME%
	devenv OpenSceneGraph.sln /Project %%i /Build %BUILDCONF%
	if errorlevel 1 (echo %%i error & goto error)
)

cd ..

tar -C %INSTDIR% -cvjf %R%\%P%-libs\%P%-libs-%V%-%B%.tar.bz2 ^
	--exclude "*.exe" ^
        bin
if errorlevel 1 goto error

tar -C %INSTDIR% -cvjf %R%\%P%-bin\%P%-bin-%V%-%B%.tar.bz2 ^
	--exclude "*.dll" ^
        bin
if errorlevel 1 goto error

tar -C %INSTDIR% -cvjf %R%\%P%-dev\%P%-dev-%V%-%B%.tar.bz2 ^
        include ^
        lib
if errorlevel 1 goto error

tar -C .. -cvjf %R%\%P%-%V%-%B%-src.tar.bz2 osgeo4w/bin.hint osgeo4w/dev.hint osgeo4w/libs.hint osgeo4w/package32.cmd
if errorlevel 1 goto error

:error
